
#deffunc gboxf int _x, int _y, int _width, int _height, int _color1, int _color2, int _mode
/*
	Of[V{bNXtB^
*/
	r1 = double(_color1 & 255)
	g1 = double(_color1 >> 8 & 255)
	b1 = double(_color1 >> 16 & 255)
	r2 = double(_color2 & 255)
	g2 = double(_color2 >> 8 & 255)
	b2 = double(_color2 >> 16 & 255)
	if (_mode & 1){
		repeat _width
			color (r2-r1)/_width*cnt+r1, (g2-g1)/_width*cnt+g1, (b2-b1)/_width*cnt+b1
			line _x+cnt, _y-1, _x+cnt, _y+_height-1
		loop
	}else{
		repeat _height
			color (r2-r1)/_height*cnt+r1, (g2-g1)/_height*cnt+g1, (b2-b1)/_height*cnt+b1
			line _x-1, _y+cnt, _x+_width-1, _y+cnt
		loop
	}
	return

#deffunc stripe int _x, int _y, int _width, int _height, int _color
/*
	XgCv`
*/
	color _color & 255, _color >> 8 & 255, _color >> 16 & 255
	repeat _height
		if ((_y +cnt) \ 2 = 0){
			line _x-1, _y+cnt, _x+_width-1, _y+cnt
		}
	loop
	return

#deffunc drawtxt str _string, int _x, int _y, int _width, int _height, int _align
/*
	eLXg`
*/
	f = 0x8000
	if (_align & 1) : f = f | 1
	if (_align & 2) : f = f | 2
	if (_align & 4) : f = f | 4 | 0x20
	if (_align & 8) : f = f | 8 | 0x20
	if (_align & 16) : f = f | 0x10
	rect = _x, _y, _x+_width, _y+_height
	DrawText hdc, _string, strlen(_string), varptr(rect), f
	return

#deffunc Drawing_SetBackground int _width, int _height, int _label
/*
	wȉ
*/
	nBackWidth = _width
	nBackHeight = _height
	nLabelHeight = _label
	buffer IDW_BACKGROUND, nBackWidth, nBackHeight
	if (bGradiant){
		gboxf 0, 0, nBackWidth, nBackHeight, nColors(CP_BACKGROUND1), nColors(CP_BACKGROUND2), 1
	}else{
		color nColors(CP_BACKGROUND1) & 255, nColors(CP_BACKGROUND1) >> 8 & 255, nColors(CP_BACKGROUND1) >> 16 & 255
		boxf
	}
	if (bStripe){
		stripe 0, 0, nBackWidth, nBackHeight, nColors(CP_STRIPE)
	}
	if (sBackground != ""){
		exist sBackground
		if (strsize > -1){
			if (getpath(sBackground, 18) = ".bmp") | ((getpath(sBackground, 18) = ".jpg")){
				picload sBackground
				nBackWidth = limit(_width, 48, 320)
				nBackHeight = limit(ginfo_winy, 1, nDispy)
				if (nWidth >= nBackWidth){
					nWidth = nBackWidth
				}
			}
		}
	}

	buffer IDW_LABEL, nBackWidth, nLabelHeight
	color nColors(CP_LABELBACK) & 255, nColors(CP_LABELBACK) >> 8 & 255, nColors(CP_LABELBACK) >> 16 & 255
	boxf
	repeat nLabelHeight
		if (bLabelPos){
			n = 256-(192/nLabelHeight*cnt)
		}else{
			n = 64+(192/nLabelHeight*cnt)
		}
		gmode 3, nBackWidth, 1, n
		pos 0, cnt
		gcopy IDW_BACKGROUND, 0, ((nHeight-nLabelHeight)*bLabelPos+cnt) \ nBackHeight
	loop

	buffer IDW_SYMBOL, 16, 16
	color : boxf
	repeat 4
		color nColors(CP_TEXT) & 255, nColors(CP_TEXT) >> 8 & 255, nColors(CP_TEXT) >> 16 & 255
		line 6+cnt, 4+cnt, 6+cnt, 11-cnt
		color nColors(CP_TEXT) & 255, nColors(CP_TEXT) >> 8 & 255, nColors(CP_TEXT) >> 16 & 255
		pset 6+cnt, 4+cnt
		pset 6+cnt, 11-cnt
	loop
	return

#deffunc Drawing_SetBlendPattern int _width, int _height
/*
	uhp^[̏
*/
	g = ginfo_sel
	buffer IDW_BLEND, _width*2, _height
	gboxf _width, 0, _width, _height/2+_height/10, 0x606060, 0x202020
	gboxf _width, _height/2+_height/10, _width, _height/2-_height/10, 0x202020, 0x404040
	color 64, 64, 64
	line _width-1, 0, _width*2, 0
	color 32, 32, 32
	line _width-1, _height-1, _width*2, _height-1
	gsel g
	return

#deffunc Drawing_Background int _x, int _y, int _width, int _height
/*
	wi`
*/
	x = _x
	y = _y
	repeat
		pos x, y
		h = nBackHeight - y \ nBackHeight
		if (y - _y + h >= _height){
			h -= y - _y + h - _height
		}
		gcopy IDW_BACKGROUND, 0, y \ nBackHeight, nBackWidth, h
		y += h
		await 
		if (y - _y >= _height){
			break
		}
	loop
	return

#deffunc Drawing_BlendPattern int _x, int _y, int _mode
/*
	uhp^[`
*/
	g = ginfo_sel
	gsel IDW_BLEND
	if (_mode){
		color nColors(CP_DOWN) & 255, nColors(CP_DOWN) >> 8 & 255, nColors(CP_DOWN) >> 16 & 255
		color 0, 0, 0
		boxf 0, 0, nBackWidth-1, nItemHeight
	}else{
		color nColors(CP_HOVER) & 255, nColors(CP_HOVER) >> 8 & 255, nColors(CP_HOVER) >> 16 & 255
		boxf 0, 0, nBackWidth-1, nItemHeight
	}
	gsel g
	gmode 7, nItemWidth, nItemHeight
	pos _x, _y
	gcopy IDW_BLEND, 0, 0
	gmode 0
	return

#deffunc Drawing_Label str _string, int _hicon, int _x
/*
	x`
*/
	if (bLabelPos){
		y = nHeight - nLabelHeight
	}else{
		y = 0
	}
	pos 0, y
	gcopy IDW_LABEL, 0, 0, nBackWidth, nLabelHeight
	color nColors(CP_LABELTEXT) & 255, nColors(CP_LABELTEXT) >> 8 & 255, nColors(CP_LABELTEXT) >> 16 & 255
	drawtxt _string, _x, y, nBackWidth-48, nLabelHeight, 6
	DrawIconEx hdc, _x+nBackWidth-40, (nHeight-32)*bLabelPos, _hicon, 32, 32, 0, 0, 3
	return

#deffunc Drawing_Item int _id, int _x, int _y, int _mode
/*
	ACe`
*/
	redraw 0
if (cl_check(xLaunch, _id)){
	if (xLaunch(_id + LAUNCH_TYPE) = LAUNCH_TYPE_SEPARATOR){
		if (_mode = 0) | (nDrag > 0){
			if (nDrag){
				Drawing_Background _x, _y, nItemWidth, nSeparatorHeight
			}
			color nColors(CP_SEPARATOR) & 255, nColors(CP_SEPARATOR) >> 8 & 255, nColors(CP_SEPARATOR) >> 16 & 255
			y = _y+nSeparatorHeight/2 - (_y+nSeparatorHeight/2)\2
			line _x-1, y-1, _x+nItemWidth, y-1
			line _x-1, y+1, _x+nItemWidth, y+1
		}
	}else{
		if (_mode > 0){
			Drawing_Background _x, _y, nItemWidth, nItemHeight
			Controls_Redraw = 1
		}
		if (bShadow){
			color nColors(CP_SHADOW) & 255, nColors(CP_SHADOW) >> 8 & 255, nColors(CP_SHADOW) >> 16 & 255
			drawtxt strref(xLaunch(_id + LAUNCH_NAME)), _x+nPaddingLeft+nIconSize+nIconMargin+2, _y+2, nItemWidth-(nPaddingLeft+nIconSize+nIconMargin+nPaddingRight), nItemHeight, 4
		}
		color nColors(CP_TEXT) & 255, nColors(CP_TEXT) >> 8 & 255, nColors(CP_TEXT) >> 16 & 255
		drawtxt strref(xLaunch(_id + LAUNCH_NAME)), _x+nPaddingLeft+nIconSize+nIconMargin, _y, nItemWidth-(nPaddingLeft+nIconSize+nIconMargin+nPaddingRight), nItemHeight, 4
		DrawIconEx hdc, _x+nPaddingLeft, _y+(nItemHeight-nIconSize)/2, xLaunch(_id + LAUNCH_HICON), nIconSize, nIconSize, 0, 0, 3
		if (xLaunch(_id + LAUNCH_TYPE) = LAUNCH_TYPE_GROUP){
			gmode 2
			pos _x+nItemWidth-24, _y+(nItemHeight-16)/2
			gcopy IDW_SYMBOL, 0, 0, 16, 16
			gmode 0
		}
		if (_mode = 2) | (_mode = 3){
			Drawing_BlendPattern _x, _y, (_mode=3)
		}
	}
	if (_mode = 4){
		color 0, 0, 0
		line _x-1, _y, _x+nItemWidth-1, _y
		color 128, 128, 128
		line _x-1, _y+1, _x+nItemWidth-1, _y+1
		color 255, 255, 255
		line _x-1, _y+2, _x+nItemWidth-1, _y+2
	}
	if (_mode > 0) & (_y + nItemHeight >= nDispy - nLabelHeight - (32 \ nLabelHeight)){
		Drawing_Label strref(xLaunch(iSelect + LAUNCH_NAME)), xLaunch(iSelect + LAUNCH_HICON)
	}
}
	bRedraw = 1
	return
